# PoKeMoNg

A [Quarkus](https://quarkus.io/) / [MongoDB](https://mongodb.com/) app for educational purposes.

Instructions [here](https://clientserveur-courses.clubinfo-clermont.fr/Notation.html).

## About

This application is a RESTful service designed to emulate a 'Pokemong' management system. It allows users to perform
CRUD operations on 'Pokemongs'.

The application is developed using the [Quarkus](https://quarkus.io/) framework and uses [MongoDB](https://mongodb.com/)
as its database.

## Prep steps

### ♨️ Java version

* #### Run locally from terminal

This project should be configured to run on `JDK 17`. That means you should have `JDK 17` installed locally, and
accessible to `Gradle`.

* #### Run from IDE

Moreover, if you're planning to run this app directly from an IDE like IntelliJ, make sure to update the `Gradle JVM`
setting to use `JDK 17` for `Gradle` tasks

### 🔐 Database connection

Note that the DB connection properties are not included -- your `src/main/resources/application.properties` should look
like this :

```yml
quarkus.mongodb.connection-string=mongodb+srv://<username>:<password>@<cluster>.<node>.mongodb.net
quarkus.mongodb.database=<database>
```

#### If you are the corrector

To be able to use this app, update `application.properties` with the provided database secrets.

If none were provided, that was a mistake. Sorry. Please request them to the owner of this repo.

#### If you are not the corrector

To be able to use this app, first create a MongoDB database, either locally or on
their [Atlas Cloud](https://cloud.mongodb.com/), then update `application.properties` with your database secrets. You
may want to look up the nice [MongoDB official documentation](https://www.mongodb.com/docs/) if you get stuck.

## Running the application in dev mode

You can run the application in dev mode using:

```shell script
./gradlew quarkusDev
```